# TVertexSkinInfo Class Reference

Inheritance diagram for TVertexSkinInfo:

List of all members.

## Public Member Functions
| TVertexSkinInfo (int32 weigthChannelCount=0)
| TVertexSkinInfo (const TVertexSkinInfo &inVertexSkinInfo)
boolean | IsValid () const
TJointIndex | GetPrimaryJointIndex () const
void | SetPrimaryJointIndex (TJointIndex primaryJointIndex)
void | PreallocateJointCount (int32 count)
int32 | GetJointsCount () const
TJointIndex | GetJointIndex (int32 index) const
int32 | GetChannelCount () const
void | SetChannelCount (int32 count)
void | RemoveAllWeights ()
void | RemoveWeight (int32 channelIndex)
void | RemoveJoint (TJointIndex index)
void | RemoveJoint (int32 index)
void | Pack ()
real32 | GetWeight (int32 jointIndex, int32 channelIndex) const
real32 & | GetWeight (int32 jointIndex, int32 channelIndex)
void | SetWeight (int32 jointIndex, int32 channelIndex, real32 weigth)
void | SetWeightNormalized (int32 jointIndex, int32 channelIndex, real32 weigth, const TJointIndex &rootJointIndex)
int32 | FindJointIndex (const TJointIndex &jointIndexToFind) const
real32 | GetJointWeight (const TJointIndex &jointIndex, int32 channelIndex) const
void | SetJointWeight (const TJointIndex &jointIndex, int32 channelIndex, real32 weigth)
void | SetJointWeightNormalized (const TJointIndex &jointIndex, int32 channelIndex, real32 weigth, const TJointIndex &rootJointIndex)
void | NormalizeWeights (int32 channelIndex, const TJointIndex &rootJointIndex, const TJointIndex &weightToKeepConst)
void | NormalizeWeights (int32 channelIndex, const TJointIndex &rootJointIndex, int32 constWeighIndex=-1)
int32 | AddJointWeight (const TJointIndex &jointIndex)
void | ComputeAverageJointsWeights (int32 inJointsCount, const TMCClassArray< TVertexSkinInfo > &inVerticesWeights, int32 channelIndex=-1)
void | CopyDataFrom (const TVertexSkinInfo &src, boolean copyPrimaryJointIndex)
void | Read (IShTokenStream &stream)
void | Write (IShTokenStream &stream) const
int32 | SizeOf ()
## Protected Attributes
TJointIndex | fPrimaryJointIndex
uint16 | fWeigthChannelCount
TMCArray< TJointIndex > | fJointIndices
TMCArray< real32 > | fWeights

## Detailed Description

Describe the skin info for a vertex. It can store multiple weights per joint.

## Constructor & Destructor Documentation

TVertexSkinInfo::TVertexSkinInfo | ( | int32 | weigthChannelCount = `0` | ) | `[inline]`

TVertexSkinInfo::TVertexSkinInfo | ( | const TVertexSkinInfo & | inVertexSkinInfo | ) | `[inline]`

## Member Function Documentation

int32 TVertexSkinInfo::AddJointWeight | ( | const TJointIndex & | jointIndex | ) |

void TVertexSkinInfo::ComputeAverageJointsWeights | ( | int32 | inJointsCount,
|  | const TMCClassArray< TVertexSkinInfo > & | inVerticesWeights,
|  | int32 | channelIndex = `-1` |
| ) |  |  |

void TVertexSkinInfo::CopyDataFrom | ( | const TVertexSkinInfo & | src,
|  | boolean | copyPrimaryJointIndex |
| ) |  |  |

int32 TVertexSkinInfo::FindJointIndex | ( | const TJointIndex & | jointIndexToFind | ) | const

int32 TVertexSkinInfo::GetChannelCount | ( |  | ) | const`[inline]`

TJointIndex TVertexSkinInfo::GetJointIndex | ( | int32 | index | ) | const`[inline]`

int32 TVertexSkinInfo::GetJointsCount | ( |  | ) | const`[inline]`

real32 TVertexSkinInfo::GetJointWeight | ( | const TJointIndex & | jointIndex,
|  | int32 | channelIndex |
| ) |  |  | const

TJointIndex TVertexSkinInfo::GetPrimaryJointIndex | ( |  | ) | const`[inline]`

real32& TVertexSkinInfo::GetWeight | ( | int32 | jointIndex,
|  | int32 | channelIndex |
| ) |  |  | `[inline]`

real32 TVertexSkinInfo::GetWeight | ( | int32 | jointIndex,
|  | int32 | channelIndex |
| ) |  |  | const`[inline]`

boolean TVertexSkinInfo::IsValid | ( |  | ) | const

void TVertexSkinInfo::NormalizeWeights | ( | int32 | channelIndex,
|  | const TJointIndex & | rootJointIndex,
|  | int32 | constWeighIndex = `-1` |
| ) |  |  |

void TVertexSkinInfo::NormalizeWeights | ( | int32 | channelIndex,
|  | const TJointIndex & | rootJointIndex,
|  | const TJointIndex & | weightToKeepConst |
| ) |  |  |

void TVertexSkinInfo::Pack | ( |  | ) |

void TVertexSkinInfo::PreallocateJointCount | ( | int32 | count | ) |

void TVertexSkinInfo::Read | ( | IShTokenStream & | stream | ) |

void TVertexSkinInfo::RemoveAllWeights | ( |  | ) |

void TVertexSkinInfo::RemoveJoint | ( | int32 | index | ) |

void TVertexSkinInfo::RemoveJoint | ( | TJointIndex | index | ) |

void TVertexSkinInfo::RemoveWeight | ( | int32 | channelIndex | ) |

void TVertexSkinInfo::SetChannelCount | ( | int32 | count | ) | `[inline]`

void TVertexSkinInfo::SetJointWeight | ( | const TJointIndex & | jointIndex,
|  | int32 | channelIndex,
|  | real32 | weigth |
| ) |  |  |

void TVertexSkinInfo::SetJointWeightNormalized | ( | const TJointIndex & | jointIndex,
|  | int32 | channelIndex,
|  | real32 | weigth,
|  | const TJointIndex & | rootJointIndex |
| ) |  |  |

void TVertexSkinInfo::SetPrimaryJointIndex | ( | TJointIndex | primaryJointIndex | ) | `[inline]`

void TVertexSkinInfo::SetWeight | ( | int32 | jointIndex,
|  | int32 | channelIndex,
|  | real32 | weigth |
| ) |  |  | `[inline]`

void TVertexSkinInfo::SetWeightNormalized | ( | int32 | jointIndex,
|  | int32 | channelIndex,
|  | real32 | weigth,
|  | const TJointIndex & | rootJointIndex |
| ) |  |  |

int32 TVertexSkinInfo::SizeOf | ( |  | ) |

void TVertexSkinInfo::Write | ( | IShTokenStream & | stream | ) | const

## Member Data Documentation

TMCArray<TJointIndex> TVertexSkinInfo::fJointIndices`[protected]`

TJointIndex TVertexSkinInfo::fPrimaryJointIndex`[protected]`

TMCArray<real32> TVertexSkinInfo::fWeights`[protected]`

uint16 TVertexSkinInfo::fWeigthChannelCount`[protected]`

The documentation for this class was generated from the following file:

- SkiningTypes.h